/*
    MSGLIB - a message handling library
    Copyright (C) 1995,1997-98  Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    See: COPYING.LB
*/
/* $RCSfile: MSG2FREE.C $
   $Locker: ska $	$Name:  $	$State: Rel $

	void msg2Free(DCL_GCAT MSGID2 id, char *text)

	Unlock the first message that matches id, text, or both.


*/

#include <stdlib.h>

#include "msg2.h"

#ifdef RCS_Version
static char const rcsid[] = 
	"$Id: MSG2FREE.C 1.2 1998/10/07 04:42:53 ska Rel ska $";
#endif /*#	defined(RCS_Version) */

void msg2Free(DCL_GCAT MSGID2 id, char *text)
{	MsgStr *str, *prv;

	if((str = msg2Find(GCAT strings, id, text, &prv)) != NULL	/* match */
	 && --str->links == 0) {	/* link count zeroed --> no longer locked */
		/* unchain from the list */
		if(prv)
			prv->nxt = str->nxt;
		else GCAT strings = str->nxt;

		free(str);
	}
}
